import 'package:flutter/foundation.dart';
import 'package:monnify_flutter_sdk/SubAccountDetails.dart';
import 'package:monnify_flutter_sdk/PaymentMethod.dart';

class Transaction {
  double amount;
  String currencyCode;
  String customerName;
  String customerEmail;
  String paymentReference;
  String paymentDescription;
  Map<String, String> metaData;
  List<PaymentMethod> paymentMethods;
  List<SubAccountDetails> incomeSplitConfig;

  Transaction(this.amount, this.currencyCode, this.customerName,
      this.customerEmail, this.paymentReference, this.paymentDescription,
      {this.metaData, this.paymentMethods, this.incomeSplitConfig});

  Map<String, dynamic> toMap() {
    var subAccountDetailsList = new List();
    if (incomeSplitConfig != null) {
      for (final subAccountDetails in incomeSplitConfig) {
        subAccountDetailsList.add(subAccountDetails.toMap());
      }
    }

    var paymentMethodsList = new List();
    if (paymentMethods != null) {
      for (final paymentMethod in paymentMethods) {
        paymentMethodsList.add(describeEnum(paymentMethod));
      }
    }

    return {
      'amount': amount,
      'currencyCode': currencyCode,
      'customerName': customerName,
      'customerEmail': customerEmail,
      'paymentReference': paymentReference,
      'paymentDescription': paymentDescription,
      'metaData': metaData,
      'paymentMethods': paymentMethodsList,
      'incomeSplitConfig': subAccountDetailsList,
    };
  }
}
