import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:monnify_flutter_sdk/Transaction.dart';
import 'package:monnify_flutter_sdk/TransactionResponse.dart';
import 'package:monnify_flutter_sdk/ApplicationMode.dart';

export 'package:monnify_flutter_sdk/Transaction.dart';
export 'package:monnify_flutter_sdk/TransactionResponse.dart';
export 'package:monnify_flutter_sdk/SubAccountDetails.dart';
export 'package:monnify_flutter_sdk/PaymentMethod.dart';
export 'package:monnify_flutter_sdk/ApplicationMode.dart';

class MonnifyFlutterSdk {
  static const MethodChannel _channel =
      const MethodChannel('monnify_flutter_sdk');

  static Future<bool> initialize(String apiKey, String contractCode,
      ApplicationMode applicationMode) async {
    Map<String, String> args = {
      "apiKey": apiKey,
      "contractCode": contractCode,
      "applicationMode": describeEnum(applicationMode)
    };

    return _channel
        .invokeMethod("initialize", args)
        .then<bool>((dynamic result) => result);
  }

  static Future<TransactionResponse> initializePayment(
      Transaction transaction) async {
    return _channel
        .invokeMethod("initializePayment", transaction.toMap())
        .then<TransactionResponse>((dynamic result) =>
            TransactionResponse.fromMap(new Map<String, dynamic>.from(result)));
  }
}
